<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>tp 6</title>
   <link rel="stylesheet" href="CSS/style.css">
</head>
<body>

    <h1>INVESTIGACIÓN JS</h1>

 <h2>1-¿Que versiones de java script hay en el mercado?</h2>
        <p>Actualmente en el mercado existen estas versiones de Javascript:</p>
        <ul>
            <li>Javascript 1</li>
            <li>Javascript 1.1</li>
            <li>Javascript 1.2</li>
            <li>Javascript 1.3</li>
            <li>Javascript 1.5</li>
            <li>5.5 de JScript</li>
            <li>ECMAScript 5</li>
            <li>ECMAScript 6</li>
        </ul>

  <h2>2-¿Como se integra Java script a html?</h2>
        <p>Para integrar un archivo JS a un HTML lo podemos hacer de 2 formas:</p>
        <ol>
            <li>Enlace interno: colocando la etiqueta "script" en algún sector del código html (puede ser dentro del body, dentro del html o entre estos dos) y dentro de la etiqueta escribir el codigo deseado.  </li>
            <li>Enlace externo: Colocamos la etiqueta "script" dentro del código del html y dentro de este agregamos la ruta al archivo script con el atributo src.  </li>
        </ol>

 
 <h2>3-¿Como es el manejo de las  variables, tipos de datos y extensiones regulares en js? </h2>
        <p>-El manejo de las variables es por medio de nombres y estas también se declaran de tres formas:</p>
        <ul>
            <li>var: Esta tiene un anclaje de función.</li>
            <li>const: Esta tiene un anclaje por bloque y estas no se pueden reasignar.</li>
            <li>let: Esta tine un anclaje por bloque y pueden se reasignadas.</li>
            
        </ul>
        <p>-Los manejo de tipo de datos se divide en 2 loos primitivos y los de objeto: </p>
        <ol>
            <li>Tipo primitivos: Estos son inmutables y no pueden ser cambiadas.
                <ul>
                    <li>String</li>
                    <li>Number</li>
                    <li>Boolean</li>
                    <li>null</li>
                    <li>undefined</li>
                    <li>Symbol</li>
                </ul>
            </li>
            <li>Tipo objeto: Estos son valores de memoria que podemos acceder por un identificador.
                <ul>
                    <li>operador typeof</li>
                    <li>Primitive wrapper </li>
                </ul>
            </li>
        </ol>
        <p>-Extensiones regulares: Estas son dos RegExp y String, las cuales se manejan por métodos:</p>
        <ol>
            <li>RegExp:
                <ul>
                    <li>exec</li>
                    <li>test</li>

                </ul>
            </li>
            <li>String
                <ul>
                    <li>match</li>
                    <li>matchAll</li>
                    <li>replace</li>
                    <li>replaceAll</li>
                    <li>search</li>
                    <li>split</li>
                </ul>
            </li>
        </ol>

 <h2>4-¿Como son todas las formas de declaración de funciones de js?</h2>
        <p>Podemos declarar las funciones de 7 maneras:</p>
        <ol>
            <li>Function declaration: En esta colocamos la palabra "function" a lado el nombre de esta (ej: calculadora), después colocamos los paramentos entre paréntesis "()" y por ultimo entre llaves {} las instrucciones.</li>
            <li>Function expression: Esta es igual a la anterior solo que en esta la función se guarda en una variable, esto lo logramos poniendo la variable = a la estructura de la función.  </li>
            <li>IIFE: Esta forma es para cuando queremos llamar a la función una sola vez y esta lo logramos poniendo a la estructura  de la función a dentro de paréntesis (estructura de la función). </li>
            <li>Shorthand method definition: Esta se utiliza como método para la declaración de un objeto o en clases de ES6, para esto asignamos un nombre a la función , después los paramentos entre paréntesis () y después entre llaves {} las intrusiones.</li>
            <li>Arrow function: Esta se hace en una sola liña y la declaramos colocando una flecha, su estructura  es colocando una variable = a los parámetros entre paréntesis y después una flecha => a las intrusiones entre llaves {}.  </li>
            <li>Generator function:En esta podemos salir en un punto determinada de la función, para esto colocamos un numeral * al comienzo de la declaración de la función.   </li>
            <li>Function constructor: Esta es para crear funciones dinámicas, esta tiene una estructura inusual, lo primero es crear una variable y lo igualamos = a la estructura de la función, esta esa compuesta por el function y entre paréntesis () los argumentos y después de esto en el mismo paréntesis las instrucciones.   </li>
        </ol>

        <h2>5-¿Cuales son los operadores y conversiones de js?</h2>
        <p>Los operadores en js tienen tipo, estos son: </p>
        <ul>
            <li>Operadores de asignación:
                <ul>
                    <li>Asignación: = </li>
                    <li>Asignación de adición: =+ </li>
                    <li>Asignacion de resta:  -= </li>
                    <li>Asignación de multiplicacion:  *=  </li>
                    <li>Asignación de division:  /= </li>
                    <li>Asignación de residuo:  %= </li>
                    <li>Asignación de exponenciación: **= </li>
                    <li>Asignación de desplazamiento a la izquierda:  <<=  </li>
                    <li>Asignación de desplazamiento a la derecha:  >>= </li>
                    <li>Asignación de desplazamiento a la derecha sin signo:  >>>= </li>
                    <li>Asignación AND bit a bit:  &= </li>
                    <li>Asignación XOR bit a bit:  ^= </li>
                    <li>Asignación OR bit a bit: |= </li>
                    <li>Asignación AND lógico: 	&&= </li>
                    <li>Asignación OR lógico:  ||= </li>
                    <li>Asignación de anulación lógica: ??= </li>

                </ul>
            </li>
            <li>Operadores de comparación:
                <ul>
                    <li>Igual: ==</li>
                    <li>No es igual: !=</li>
                    <li>Estrictamente igual: ===</li>
                    <li>Desigualdad estricta: !==</li>
                    <li>Mayor que: > </li>
                    <li>Mayor o igual que: >= </li>
                    <li>Menor que: < </li>
                    <li>Menor o igual: <= </li>

                </ul>
            </li>
            <li>Operadores aritméticos:</li>
                <ul>
                    <li>Residuo: % </li>
                    <li>Incremento: ++ </li>
                    <li>Decremento: -- </li>
                    <li>Negación unaria: - </li>
                    <li>Positivo unario: + </li>
                    <li>Operador de exponenciación: ** </li>
                </ul>
            <li>Operadores bit a bit:</li>
                <ul>
                    <li>AND a nivel de bits: & </li>
                    <li>OR a nivel de bits: | </li>
                    <li>XOR a nivel de bits: ^ </li>
                    <li>NOT a nivel de bits: ~ </li>
                    <li>Desplazamiento a la izquierda: << </li>
                    <li>Desplazamiento a la derecha de propagación de signo: >> </li>
                    <li>Desplazamiento a la derecha de relleno cero: >>> </li>
                </ul>
            <li>Operadores lógicos:</li>
            <ul>
                <li>AND Lógico: && </li>
                <li>OR lógico: || </li>
                <li>NOT lógico: ! </li>
            </ul>

        </ul>
        <p>Las conversiones en js son tres: </p>
        <ul>
            <li>ToSting</li>
            <li>ToNumber</li>
            <li>ToBoolean</li>

        </ul>

  <h2>6-¿Cuales son las estructuras de control de js?
        </h2>
        <p>En JS existen dos tipos de estructuras de control:</p>
        <ol>
            <li>Estructuras condicionales: En esta el objetivo es realizar una bifurcación del flujo de las introducciones; en estas nosotros establecemos una conducción en algún punto del programa para que este siga ejecutando. </li>
            <li>Estructuras de repetición: Esta estructura son bucles que se utilizan para realizar la misma acción de forma indefinida. </li>
        </ol>
   
  <h2>7-¿Que es el objeto dom en js? ¿Como trabaja? </h2>
        <p>El dom es una interfaz de programación para crear, cambiar y remover elementos de un documento, este trabaja representando al documento HTML en un solo objeto, por medio del navegador web toma  las etiquetas  de este.  </p>
       
 <h2>8-¿Que función tiene en js el Object Map?</h2>
        <p>Map es una colección de elementos en la que cada elemento se almacena como un par clave-valor y tiene la función de recordar exactamente el orden de como se ingresaron los valore-claves.</p>

 <h2>9-¿Cuales son todos los eventos que trabaja js?</h2>
        <p>Los eventos que trabaja js son:</p>
        <ul>
            <li>abort (onabort).</li>
            <li>blur (onblur).</li>
            <li>change (onchange).</li>
            <li>click (onclick).</li>
            <li>dragdrop (ondragdrop).</li>
            <li>error (onerror).</li>
            <li>focus (onfocus).</li>
            <li>keydown (onkeydown).</li>
            <li>keypress (onkeypress).</li>
            <li>keyup (onkeyup).</li>
            <li>load (onload).</li>
            <li>mousedown (onmousedown).</li>
            <li>mousemove (onmousemove).</li>
            <li>mouseout (onmouseout).</li>
            <li>mouseover (onmouseover).</li>
            <li>mouseup (onmouseup).</li>
            <li>move (onmove).</li>
            <li>resize (onresize).</li>
            <li>reset (onreset).</li>
            <li>select (onselect).</li>
            <li>submit (onsubmit).</li>
            <li>unload (onunload).</li>
            <li>DblClick (ondblclick).</li>
            <li>scroll (onscroll).</li>
        </ul>
 
 <h2>10-Con toda la investigación que generaron debe un formulario que realize las siguientes funciones.</h2>
        <ul>
            <li>a)¿Que obtengan los datos del input? Para obtener los datos de un input utilizamos la propiedad  getElementById.</li>
            <li>b)¿Que verifique los datos que se integran en el input? Para verificar los datos que se ingresan en un input utilizamos la propiedad document.getElementById().</li>
            <li>c)¿Que el formulario presente un calculo de sumatoria para verificar "¿Que no es un robot?"? Para realizar esto utilizamos dom y el propiedad getElementByName o getElementById.</li>

        </ul>

</body>
</html>